-- Do not edit.  Generated by cheby 1.7.dev0 using these options:
--  --header commit --gen-hdl vme_map.vhd --gen-c ../../sw/hw-include/vme_map.h -i vme_map.cheby


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

entity vme_map is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_i                 : in    t_wishbone_slave_in;
    wb_o                 : out   t_wishbone_slave_out;

    -- WB bus host
    host_i               : in    t_wishbone_master_in;
    host_o               : out   t_wishbone_master_out;

    -- REG irq
    -- VME irq level
    vme_irq_level_o      : out   std_logic_vector(2 downto 0);
    -- VME irq vector
    vme_irq_vector_o     : out   std_logic_vector(7 downto 0);

    -- REG ga
    -- VME geographical address
    vme_ga_vme_ga_i      : in    std_logic_vector(5 downto 0);
    -- Switch address
    vme_ga_noga_i        : in    std_logic_vector(5 downto 0);
    -- Decided ga
    vme_ga_ga_i          : in    std_logic_vector(5 downto 0);
    -- Constant
    vme_ga_cst_i         : in    std_logic_vector(7 downto 0);

    -- REG p2_rs485
    vme_p2_rs485_dat0_i  : in    std_logic;
    vme_p2_rs485_dat0_o  : out   std_logic;
    vme_p2_rs485_dat1_i  : in    std_logic;
    vme_p2_rs485_dat1_o  : out   std_logic;
    -- 0: input, 1: output
    vme_p2_rs485_dir0_o  : out   std_logic;
    -- 0: input, 1: output
    vme_p2_rs485_dir1_o  : out   std_logic;
    vme_p2_rs485_wr_o    : out   std_logic;

    -- REG p2_ttc
    vme_p2_ttc_dat_o     : out   std_logic_vector(1 downto 0);

    -- REG hwbytes_l1
    vme_hwbytes_l1_o     : out   std_logic_vector(7 downto 0);

    -- REG hwbytes_h1
    vme_hwbytes_h1_o     : out   std_logic_vector(7 downto 0);

    -- REG hwbytes_l2
    vme_hwbytes_l2_o     : out   std_logic_vector(7 downto 0);

    -- REG hwbytes_h2
    vme_hwbytes_h2_o     : out   std_logic_vector(7 downto 0);

    -- REG hwbytes_oe
    vme_hwbytes_oe_l1_o  : out   std_logic;
    vme_hwbytes_oe_h1_o  : out   std_logic;
    vme_hwbytes_oe_l2_o  : out   std_logic;
    vme_hwbytes_oe_h2_o  : out   std_logic;

    -- REG p0_clk
    vme_p0_clk_ttl_oe_o  : out   std_logic;

    -- Divisor between bunch and turn clock
    vme_p0_h1_o          : out   std_logic_vector(15 downto 0);

    -- base address of the windows area, 4KB per window
    vme_base_addr_adr_o  : out   std_logic_vector(4 downto 2);
    vme_base_addr_dato_i : in    std_logic_vector(31 downto 0);
    vme_base_addr_dati_o : out   std_logic_vector(31 downto 0);
    vme_base_addr_rd_o   : out   std_logic;
    vme_base_addr_wr_o   : out   std_logic;
    vme_base_addr_rack_i : in    std_logic;
    vme_base_addr_wack_i : in    std_logic;

    -- windowed access to the board memory (4KB)
    windows_adr_o        : out   std_logic_vector(14 downto 2);
    windows_dato_i       : in    std_logic_vector(31 downto 0);
    windows_dati_o       : out   std_logic_vector(31 downto 0);
    windows_rd_o         : out   std_logic;
    windows_wr_o         : out   std_logic;
    windows_rack_i       : in    std_logic;
    windows_wack_i       : in    std_logic
  );
end vme_map;

architecture syn of vme_map is
  signal wr_sel                         : std_logic_vector(31 downto 0);
  signal adr_int                        : std_logic_vector(15 downto 2);
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal host_re                        : std_logic;
  signal host_we                        : std_logic;
  signal host_wt                        : std_logic;
  signal host_rt                        : std_logic;
  signal host_tr                        : std_logic;
  signal host_wack                      : std_logic;
  signal host_rack                      : std_logic;
  signal vme_irq_level_reg              : std_logic_vector(2 downto 0);
  signal vme_irq_vector_reg             : std_logic_vector(7 downto 0);
  signal vme_irq_wreq                   : std_logic;
  signal vme_irq_wack                   : std_logic;
  signal vme_p2_rs485_dir0_reg          : std_logic;
  signal vme_p2_rs485_dir1_reg          : std_logic;
  signal vme_p2_rs485_wreq              : std_logic;
  signal vme_p2_rs485_wack              : std_logic;
  signal vme_p2_rs485_wstrb             : std_logic;
  signal vme_p2_ttc_dat_reg             : std_logic_vector(1 downto 0);
  signal vme_p2_ttc_wreq                : std_logic;
  signal vme_p2_ttc_wack                : std_logic;
  signal vme_hwbytes_l1_reg             : std_logic_vector(7 downto 0);
  signal vme_hwbytes_l1_wreq            : std_logic;
  signal vme_hwbytes_l1_wack            : std_logic;
  signal vme_hwbytes_h1_reg             : std_logic_vector(7 downto 0);
  signal vme_hwbytes_h1_wreq            : std_logic;
  signal vme_hwbytes_h1_wack            : std_logic;
  signal vme_hwbytes_l2_reg             : std_logic_vector(7 downto 0);
  signal vme_hwbytes_l2_wreq            : std_logic;
  signal vme_hwbytes_l2_wack            : std_logic;
  signal vme_hwbytes_h2_reg             : std_logic_vector(7 downto 0);
  signal vme_hwbytes_h2_wreq            : std_logic;
  signal vme_hwbytes_h2_wack            : std_logic;
  signal vme_hwbytes_oe_l1_reg          : std_logic;
  signal vme_hwbytes_oe_h1_reg          : std_logic;
  signal vme_hwbytes_oe_l2_reg          : std_logic;
  signal vme_hwbytes_oe_h2_reg          : std_logic;
  signal vme_hwbytes_oe_wreq            : std_logic;
  signal vme_hwbytes_oe_wack            : std_logic;
  signal vme_p0_clk_ttl_oe_reg          : std_logic;
  signal vme_p0_clk_wreq                : std_logic;
  signal vme_p0_clk_wack                : std_logic;
  signal vme_p0_h1_reg                  : std_logic_vector(15 downto 0);
  signal vme_p0_h1_wreq                 : std_logic;
  signal vme_p0_h1_wack                 : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(15 downto 2);
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_sel_d0                      : std_logic_vector(31 downto 0);
  signal vme_base_addr_ws               : std_logic;
  signal vme_base_addr_wt               : std_logic;
  signal windows_ws                     : std_logic;
  signal windows_wt                     : std_logic;
begin

  -- WB decode signals
  process (wb_i.sel) begin
    wr_sel(7 downto 0) <= (others => wb_i.sel(0));
    wr_sel(15 downto 8) <= (others => wb_i.sel(1));
    wr_sel(23 downto 16) <= (others => wb_i.sel(2));
    wr_sel(31 downto 24) <= (others => wb_i.sel(3));
  end process;
  adr_int <= wb_i.adr(15 downto 2);
  wb_en <= wb_i.cyc and wb_i.stb;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_i.we)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_i.we) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_i.we)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_i.we) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_o.ack <= ack_int;
  wb_o.stall <= not ack_int and wb_en;
  wb_o.rty <= '0';
  wb_o.err <= '0';

  -- pipelining for wr-in+rd-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_ack_int <= '0';
        wb_o.dat <= "00000000000000000000000000000000";
        wr_req_d0 <= '0';
        wr_adr_d0 <= "00000000000000";
        wr_dat_d0 <= "00000000000000000000000000000000";
        wr_sel_d0 <= "00000000000000000000000000000000";
      else
        rd_ack_int <= rd_ack_d0;
        wb_o.dat <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_adr_d0 <= adr_int;
        wr_dat_d0 <= wb_i.dat;
        wr_sel_d0 <= wr_sel;
      end if;
    end if;
  end process;

  -- Interface host
  host_tr <= host_wt or host_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        host_rt <= '0';
        host_wt <= '0';
      else
        host_rt <= (host_rt or host_re) and not host_rack;
        host_wt <= (host_wt or host_we) and not host_wack;
      end if;
    end if;
  end process;
  host_o.cyc <= host_tr;
  host_o.stb <= host_tr;
  host_wack <= host_i.ack and host_wt;
  host_rack <= host_i.ack and host_rt;
  host_o.adr <= ((18 downto 0 => '0') & adr_int(12 downto 2)) & (1 downto 0 => '0');
  process (wr_sel_d0) begin
    host_o.sel <= (others => '0');
    if not (wr_sel_d0(7 downto 0) = (7 downto 0 => '0')) then
      host_o.sel(0) <= '1';
    end if;
    if not (wr_sel_d0(15 downto 8) = (7 downto 0 => '0')) then
      host_o.sel(1) <= '1';
    end if;
    if not (wr_sel_d0(23 downto 16) = (7 downto 0 => '0')) then
      host_o.sel(2) <= '1';
    end if;
    if not (wr_sel_d0(31 downto 24) = (7 downto 0 => '0')) then
      host_o.sel(3) <= '1';
    end if;
  end process;
  host_o.we <= host_wt;
  host_o.dat <= wr_dat_d0;

  -- Register vme_irq
  vme_irq_level_o <= vme_irq_level_reg;
  vme_irq_vector_o <= vme_irq_vector_reg;
  vme_irq_wack <= vme_irq_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_irq_level_reg <= "000";
        vme_irq_vector_reg <= "00000000";
      else
        if vme_irq_wreq = '1' then
          vme_irq_level_reg <= wr_dat_d0(2 downto 0);
          vme_irq_vector_reg <= wr_dat_d0(15 downto 8);
        end if;
      end if;
    end if;
  end process;

  -- Register vme_ga

  -- Register vme_p2_rs485
  vme_p2_rs485_dat0_o <= wr_dat_d0(0);
  vme_p2_rs485_dat1_o <= wr_dat_d0(1);
  vme_p2_rs485_dir0_o <= vme_p2_rs485_dir0_reg;
  vme_p2_rs485_dir1_o <= vme_p2_rs485_dir1_reg;
  vme_p2_rs485_wack <= vme_p2_rs485_wreq;
  vme_p2_rs485_wstrb <= vme_p2_rs485_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_p2_rs485_dir0_reg <= '0';
        vme_p2_rs485_dir1_reg <= '0';
      else
        if vme_p2_rs485_wreq = '1' then
          vme_p2_rs485_dir0_reg <= wr_dat_d0(4);
          vme_p2_rs485_dir1_reg <= wr_dat_d0(5);
        end if;
      end if;
    end if;
  end process;
  vme_p2_rs485_wr_o <= vme_p2_rs485_wstrb;

  -- Register vme_p2_ttc
  vme_p2_ttc_dat_o <= vme_p2_ttc_dat_reg;
  vme_p2_ttc_wack <= vme_p2_ttc_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_p2_ttc_dat_reg <= "00";
      else
        if vme_p2_ttc_wreq = '1' then
          vme_p2_ttc_dat_reg <= wr_dat_d0(1 downto 0);
        end if;
      end if;
    end if;
  end process;

  -- Register vme_hwbytes_l1
  vme_hwbytes_l1_o <= vme_hwbytes_l1_reg;
  vme_hwbytes_l1_wack <= vme_hwbytes_l1_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_hwbytes_l1_reg <= "00000000";
      else
        if vme_hwbytes_l1_wreq = '1' then
          vme_hwbytes_l1_reg <= wr_dat_d0(7 downto 0);
        end if;
      end if;
    end if;
  end process;

  -- Register vme_hwbytes_h1
  vme_hwbytes_h1_o <= vme_hwbytes_h1_reg;
  vme_hwbytes_h1_wack <= vme_hwbytes_h1_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_hwbytes_h1_reg <= "00000000";
      else
        if vme_hwbytes_h1_wreq = '1' then
          vme_hwbytes_h1_reg <= wr_dat_d0(7 downto 0);
        end if;
      end if;
    end if;
  end process;

  -- Register vme_hwbytes_l2
  vme_hwbytes_l2_o <= vme_hwbytes_l2_reg;
  vme_hwbytes_l2_wack <= vme_hwbytes_l2_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_hwbytes_l2_reg <= "00000000";
      else
        if vme_hwbytes_l2_wreq = '1' then
          vme_hwbytes_l2_reg <= wr_dat_d0(7 downto 0);
        end if;
      end if;
    end if;
  end process;

  -- Register vme_hwbytes_h2
  vme_hwbytes_h2_o <= vme_hwbytes_h2_reg;
  vme_hwbytes_h2_wack <= vme_hwbytes_h2_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_hwbytes_h2_reg <= "00000000";
      else
        if vme_hwbytes_h2_wreq = '1' then
          vme_hwbytes_h2_reg <= wr_dat_d0(7 downto 0);
        end if;
      end if;
    end if;
  end process;

  -- Register vme_hwbytes_oe
  vme_hwbytes_oe_l1_o <= vme_hwbytes_oe_l1_reg;
  vme_hwbytes_oe_h1_o <= vme_hwbytes_oe_h1_reg;
  vme_hwbytes_oe_l2_o <= vme_hwbytes_oe_l2_reg;
  vme_hwbytes_oe_h2_o <= vme_hwbytes_oe_h2_reg;
  vme_hwbytes_oe_wack <= vme_hwbytes_oe_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_hwbytes_oe_l1_reg <= '0';
        vme_hwbytes_oe_h1_reg <= '0';
        vme_hwbytes_oe_l2_reg <= '0';
        vme_hwbytes_oe_h2_reg <= '0';
      else
        if vme_hwbytes_oe_wreq = '1' then
          vme_hwbytes_oe_l1_reg <= wr_dat_d0(0);
          vme_hwbytes_oe_h1_reg <= wr_dat_d0(1);
          vme_hwbytes_oe_l2_reg <= wr_dat_d0(2);
          vme_hwbytes_oe_h2_reg <= wr_dat_d0(3);
        end if;
      end if;
    end if;
  end process;

  -- Register vme_p0_clk
  vme_p0_clk_ttl_oe_o <= vme_p0_clk_ttl_oe_reg;
  vme_p0_clk_wack <= vme_p0_clk_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_p0_clk_ttl_oe_reg <= '0';
      else
        if vme_p0_clk_wreq = '1' then
          vme_p0_clk_ttl_oe_reg <= wr_dat_d0(0);
        end if;
      end if;
    end if;
  end process;

  -- Register vme_p0_h1
  vme_p0_h1_o <= vme_p0_h1_reg;
  vme_p0_h1_wack <= vme_p0_h1_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_p0_h1_reg <= "0000000000000000";
      else
        if vme_p0_h1_wreq = '1' then
          vme_p0_h1_reg <= wr_dat_d0(15 downto 0);
        end if;
      end if;
    end if;
  end process;

  -- Interface vme_base_addr
  vme_base_addr_dati_o <= wr_dat_d0;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        vme_base_addr_wt <= '0';
      else
        vme_base_addr_wt <= (vme_base_addr_wt or vme_base_addr_ws) and not vme_base_addr_wack_i;
      end if;
    end if;
  end process;
  vme_base_addr_wr_o <= vme_base_addr_ws;
  process (adr_int, wr_adr_d0, vme_base_addr_wt, vme_base_addr_ws) begin
    if (vme_base_addr_ws or vme_base_addr_wt) = '1' then
      vme_base_addr_adr_o <= wr_adr_d0(4 downto 2);
    else
      vme_base_addr_adr_o <= adr_int(4 downto 2);
    end if;
  end process;

  -- Interface windows
  windows_dati_o <= wr_dat_d0;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        windows_wt <= '0';
      else
        windows_wt <= (windows_wt or windows_ws) and not windows_wack_i;
      end if;
    end if;
  end process;
  windows_wr_o <= windows_ws;
  process (adr_int, wr_adr_d0, windows_wt, windows_ws) begin
    if (windows_ws or windows_wt) = '1' then
      windows_adr_o <= wr_adr_d0(14 downto 2);
    else
      windows_adr_o <= adr_int(14 downto 2);
    end if;
  end process;

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, host_wack, vme_irq_wack, vme_p2_rs485_wack,
           vme_p2_ttc_wack, vme_hwbytes_l1_wack, vme_hwbytes_h1_wack,
           vme_hwbytes_l2_wack, vme_hwbytes_h2_wack, vme_hwbytes_oe_wack,
           vme_p0_clk_wack, vme_p0_h1_wack, vme_base_addr_wack_i, windows_wack_i) begin
    host_we <= '0';
    vme_irq_wreq <= '0';
    vme_p2_rs485_wreq <= '0';
    vme_p2_ttc_wreq <= '0';
    vme_hwbytes_l1_wreq <= '0';
    vme_hwbytes_h1_wreq <= '0';
    vme_hwbytes_l2_wreq <= '0';
    vme_hwbytes_h2_wreq <= '0';
    vme_hwbytes_oe_wreq <= '0';
    vme_p0_clk_wreq <= '0';
    vme_p0_h1_wreq <= '0';
    vme_base_addr_ws <= '0';
    windows_ws <= '0';
    case wr_adr_d0(15 downto 15) is
    when "0" =>
      case wr_adr_d0(14 downto 13) is
      when "00" =>
        -- Submap host
        host_we <= wr_req_d0;
        wr_ack_int <= host_wack;
      when "01" =>
        case wr_adr_d0(12 downto 5) is
        when "00000000" =>
          case wr_adr_d0(4 downto 2) is
          when "000" =>
            -- Reg vme_irq
            vme_irq_wreq <= wr_req_d0;
            wr_ack_int <= vme_irq_wack;
          when "001" =>
            -- Reg vme_ga
            wr_ack_int <= wr_req_d0;
          when "010" =>
            -- Reg vme_p2_rs485
            vme_p2_rs485_wreq <= wr_req_d0;
            wr_ack_int <= vme_p2_rs485_wack;
          when "011" =>
            -- Reg vme_p2_ttc
            vme_p2_ttc_wreq <= wr_req_d0;
            wr_ack_int <= vme_p2_ttc_wack;
          when "100" =>
            -- Reg vme_hwbytes_l1
            vme_hwbytes_l1_wreq <= wr_req_d0;
            wr_ack_int <= vme_hwbytes_l1_wack;
          when "101" =>
            -- Reg vme_hwbytes_h1
            vme_hwbytes_h1_wreq <= wr_req_d0;
            wr_ack_int <= vme_hwbytes_h1_wack;
          when "110" =>
            -- Reg vme_hwbytes_l2
            vme_hwbytes_l2_wreq <= wr_req_d0;
            wr_ack_int <= vme_hwbytes_l2_wack;
          when "111" =>
            -- Reg vme_hwbytes_h2
            vme_hwbytes_h2_wreq <= wr_req_d0;
            wr_ack_int <= vme_hwbytes_h2_wack;
          when others =>
            wr_ack_int <= wr_req_d0;
          end case;
        when "00000001" =>
          case wr_adr_d0(4 downto 2) is
          when "000" =>
            -- Reg vme_hwbytes_oe
            vme_hwbytes_oe_wreq <= wr_req_d0;
            wr_ack_int <= vme_hwbytes_oe_wack;
          when "001" =>
            -- Reg vme_p0_clk
            vme_p0_clk_wreq <= wr_req_d0;
            wr_ack_int <= vme_p0_clk_wack;
          when "010" =>
            -- Reg vme_p0_h1
            vme_p0_h1_wreq <= wr_req_d0;
            wr_ack_int <= vme_p0_h1_wack;
          when others =>
            wr_ack_int <= wr_req_d0;
          end case;
        when "00010000" =>
          -- Memory vme_base_addr
          vme_base_addr_ws <= wr_req_d0;
          wr_ack_int <= vme_base_addr_wack_i;
        when others =>
          wr_ack_int <= wr_req_d0;
        end case;
      when others =>
        wr_ack_int <= wr_req_d0;
      end case;
    when "1" =>
      -- Submap windows
      windows_ws <= wr_req_d0;
      wr_ack_int <= windows_wack_i;
    when others =>
      wr_ack_int <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (adr_int, rd_req_int, host_i.dat, host_rack, vme_irq_level_reg,
           vme_irq_vector_reg, vme_ga_vme_ga_i, vme_ga_noga_i, vme_ga_ga_i,
           vme_ga_cst_i, vme_p2_rs485_dat0_i, vme_p2_rs485_dat1_i,
           vme_p2_rs485_dir0_reg, vme_p2_rs485_dir1_reg, vme_p2_ttc_dat_reg,
           vme_hwbytes_l1_reg, vme_hwbytes_h1_reg, vme_hwbytes_l2_reg,
           vme_hwbytes_h2_reg, vme_hwbytes_oe_l1_reg, vme_hwbytes_oe_h1_reg,
           vme_hwbytes_oe_l2_reg, vme_hwbytes_oe_h2_reg, vme_p0_clk_ttl_oe_reg,
           vme_p0_h1_reg, vme_base_addr_dato_i, vme_base_addr_rack_i,
           windows_dato_i, windows_rack_i) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    host_re <= '0';
    vme_base_addr_rd_o <= '0';
    windows_rd_o <= '0';
    case adr_int(15 downto 15) is
    when "0" =>
      case adr_int(14 downto 13) is
      when "00" =>
        -- Submap host
        host_re <= rd_req_int;
        rd_dat_d0 <= host_i.dat;
        rd_ack_d0 <= host_rack;
      when "01" =>
        case adr_int(12 downto 5) is
        when "00000000" =>
          case adr_int(4 downto 2) is
          when "000" =>
            -- Reg vme_irq
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(2 downto 0) <= vme_irq_level_reg;
            rd_dat_d0(7 downto 3) <= (others => '0');
            rd_dat_d0(15 downto 8) <= vme_irq_vector_reg;
            rd_dat_d0(31 downto 16) <= (others => '0');
          when "001" =>
            -- Reg vme_ga
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(5 downto 0) <= vme_ga_vme_ga_i;
            rd_dat_d0(7 downto 6) <= (others => '0');
            rd_dat_d0(13 downto 8) <= vme_ga_noga_i;
            rd_dat_d0(15 downto 14) <= (others => '0');
            rd_dat_d0(21 downto 16) <= vme_ga_ga_i;
            rd_dat_d0(23 downto 22) <= (others => '0');
            rd_dat_d0(31 downto 24) <= vme_ga_cst_i;
          when "010" =>
            -- Reg vme_p2_rs485
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= vme_p2_rs485_dat0_i;
            rd_dat_d0(1) <= vme_p2_rs485_dat1_i;
            rd_dat_d0(3 downto 2) <= (others => '0');
            rd_dat_d0(4) <= vme_p2_rs485_dir0_reg;
            rd_dat_d0(5) <= vme_p2_rs485_dir1_reg;
            rd_dat_d0(31 downto 6) <= (others => '0');
          when "011" =>
            -- Reg vme_p2_ttc
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(1 downto 0) <= vme_p2_ttc_dat_reg;
            rd_dat_d0(31 downto 2) <= (others => '0');
          when "100" =>
            -- Reg vme_hwbytes_l1
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(7 downto 0) <= vme_hwbytes_l1_reg;
            rd_dat_d0(31 downto 8) <= (others => '0');
          when "101" =>
            -- Reg vme_hwbytes_h1
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(7 downto 0) <= vme_hwbytes_h1_reg;
            rd_dat_d0(31 downto 8) <= (others => '0');
          when "110" =>
            -- Reg vme_hwbytes_l2
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(7 downto 0) <= vme_hwbytes_l2_reg;
            rd_dat_d0(31 downto 8) <= (others => '0');
          when "111" =>
            -- Reg vme_hwbytes_h2
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(7 downto 0) <= vme_hwbytes_h2_reg;
            rd_dat_d0(31 downto 8) <= (others => '0');
          when others =>
            rd_ack_d0 <= rd_req_int;
          end case;
        when "00000001" =>
          case adr_int(4 downto 2) is
          when "000" =>
            -- Reg vme_hwbytes_oe
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= vme_hwbytes_oe_l1_reg;
            rd_dat_d0(1) <= vme_hwbytes_oe_h1_reg;
            rd_dat_d0(2) <= vme_hwbytes_oe_l2_reg;
            rd_dat_d0(3) <= vme_hwbytes_oe_h2_reg;
            rd_dat_d0(31 downto 4) <= (others => '0');
          when "001" =>
            -- Reg vme_p0_clk
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= vme_p0_clk_ttl_oe_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when "010" =>
            -- Reg vme_p0_h1
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(15 downto 0) <= vme_p0_h1_reg;
            rd_dat_d0(31 downto 16) <= (others => '0');
          when others =>
            rd_ack_d0 <= rd_req_int;
          end case;
        when "00010000" =>
          -- Memory vme_base_addr
          vme_base_addr_rd_o <= rd_req_int;
          rd_dat_d0 <= vme_base_addr_dato_i;
          rd_ack_d0 <= vme_base_addr_rack_i;
        when others =>
          rd_ack_d0 <= rd_req_int;
        end case;
      when others =>
        rd_ack_d0 <= rd_req_int;
      end case;
    when "1" =>
      -- Submap windows
      windows_rd_o <= rd_req_int;
      rd_dat_d0 <= windows_dato_i;
      rd_ack_d0 <= windows_rack_i;
    when others =>
      rd_ack_d0 <= rd_req_int;
    end case;
  end process;
end syn;
